<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;


class EventoEstruturaService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function novo($nrestruturam, $nreventom, $dtinivigencia, $dtfimvigencia, $periodicidademes, $nrvalorreferenciam, $vrpercent, $vrmultiplic, $vrdivide, $vreventofixo, $idrefgerar, $idretreferencia, 
                         $vrreffixo, $idtipomovimento, $vrpisoevento, $vrtetoevento, $dsobservacao, $nrtpagrupacalc, $idgeraafastado)
    {
        $fpa_Estrutevento = Repositories::FPA_ESTRUTEVENTO;
        
        $evento = new $fpa_Estrutevento;
        $evento->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $evento->setNrestruturam($nrestruturam);
        $evento->setNreventom($nreventom);
        $evento->setDtinivigencia($dtinivigencia);
        $evento->setDtfimvigencia($dtfimvigencia);
        $evento->setPeriodicidademes($periodicidademes);
        $evento->setNrvalorreferenciam($nrvalorreferenciam);
        $evento->setVrpercent($vrpercent);
        $evento->setVrmultiplic($vrmultiplic);
        $evento->setVrdivide($vrdivide);
        $evento->setVreventofixo($vreventofixo);
        $evento->setIdrefgerar($idrefgerar);
        $evento->setIdretreferencia($idretreferencia);
        $evento->setVrreffixo($vrreffixo);
        $evento->setIdtipomovimento($idtipomovimento);
        $evento->setVrpisoevento($vrpisoevento);
        $evento->setVrtetoevento($vrtetoevento);
        $evento->setDsobservacao($dsobservacao);
        $evento->setNrtpagrupacalc($nrtpagrupacalc);
        $evento->setIdgeraafastado($idgeraafastado);
        $evento->setDtinclusao(DateUtil::getDataAtual()); 
        $evento->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $evento->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $evento->setDtultatu(DateUtil::getDataAtual());
        $evento->setCdoperultatu($this->hcmParameters->getCdoperador());
        $evento->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        
        $evento->setNrestrutevento(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_ESTRUTEVENTO', 1, 12, true));
        
        $this->entityManager->persist($evento);
        $this->entityManager->flush();
        
        return $evento;
    }
    
}