<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class CidRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function getCid($dataset) {
        $query = "
               SELECT *
                FROM SST_CID
                WHERE NRCID <> 0
                AND IDNIVELCID = 1
                AND NRCID IN (SELECT NRCIDPAI
                FROM SST_CID
                WHERE NRCID <> 0
                AND (upper(CDCID) LIKE upper(:CDCID) OR upper(:CDCID) IS NULL)
                AND (upper(DSCID) LIKE upper(:DSCID) OR upper(:DSCID) IS NULL)
                AND (IDNIVELCID LIKE :IDNIVELCID OR :IDNIVELCID IS NULL)
                AND (IDCIDRESTRITOSEXO LIKE :IDCIDRESTRITOSEXO OR :IDCIDRESTRITOSEXO IS NULL)
                )
                UNION
                    SELECT *
                    FROM SST_CID
                    WHERE NRCID <> 0
                    AND (upper(CDCID) LIKE upper(:CDCID) OR upper(:CDCID) IS NULL)
                    AND (upper(DSCID) LIKE upper(:DSCID) OR upper(:DSCID) IS NULL)
                    AND (IDNIVELCID LIKE :IDNIVELCID OR :IDNIVELCID IS NULL)
                    AND (IDCIDRESTRITOSEXO LIKE :IDCIDRESTRITOSEXO OR :IDCIDRESTRITOSEXO IS NULL)";

        return $this->connection->fetchAll($query,
            array(
                "CDCID" => $dataset[0],
                "DSCID" => $dataset[1],
                "IDNIVELCID" => $dataset[2],
                "IDCIDRESTRITOSEXO" => $dataset[3]
            )
        );
    }

} 

