<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Metarisl extends Base\Metarisl
{
    /**
     * Método para salvar os percentuais de Resto Ingesta e/ou Sobra Limpa cada Unidade na Tabela
     * @params $linhas
     * @params $data
     * @return null
     * @throws \Exception
     */
    public static function saveMetas($linhas, $data)
    {
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $data = DateUtil::getDataDeString($data);
            $data = DateUtil::truncateData($data);
            foreach ($linhas as $registro) {
                /**
                 * Linhas da tabela de acordo com o mês filtrado
                 * @var Metarisl $metarisl
                 */
                $metarisl = Metarisl::getObjectsByWhere('CDFILIAL = ? AND DTREFMETRISL = ? AND NRORG = ?', array($registro['CDFILIAL'], $data, $registro['NRORG']));

                if ($metarisl == false) {
                    $metarisl = new Metarisl();
                    $metarisl->setCdfilial($registro['CDFILIAL']);
                    $metarisl->setDtrefmetrisl($data);
                    $metarisl->setVrpemetarein($registro['VRPEMETAREIN']);
                    $metarisl->setVrpemetasoli($registro['VRPEMETASOLI']);
                    $metarisl->setNrorg(Ambiente::getNrorg());
                    $metarisl->setDtinclusao(DateUtil::getDataAtual());
                    $metarisl->setDtultatu(DateUtil::getDataAtual());
                    $metarisl->setNrorginclusao(Ambiente::getNrorg());
                    $metarisl->setCdoperinclusao(Ambiente::getCdOperador());
                    $metarisl->setNrorgultatu(Ambiente::getNrorg());
                    $metarisl->setCdoperultatu(Ambiente::getCdOperador());

                    $metarisl->persist();
                } else {
                    foreach ($metarisl as $row) {
                        /**
                         * Colocando $row como instancia de Metarisl
                         * @var Metarisl $row
                         */
                        $row->setVrpemetarein($registro['VRPEMETAREIN']);
                        $row->setVrpemetasoli($registro['VRPEMETASOLI']);
                        $row->setNrorg(Ambiente::getNrorg());
                        $row->setDtinclusao(DateUtil::getDataAtual());
                        $row->setDtultatu(DateUtil::getDataAtual());
                        $row->setNrorginclusao(Ambiente::getNrorg());
                        $row->setCdoperinclusao(Ambiente::getCdOperador());
                        $row->setNrorgultatu(Ambiente::getNrorg());
                        $row->setCdoperultatu(Ambiente::getCdOperador());

                        $row->persist();
                    }
                }
            }
            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            throw $e;
        }
    }
}