/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

   TROCA_PRATO_CARD

   Procedure para substituir pratos no cardpio
   Criao: Dmaso (13/12/05)

   @C:\WEB_411\SQL\END_CONV\SQLSERVER\7820_PLASTPS_TROCA_PRATO_CARD.SQL
   EXECUTE TEKNISA.TROCA_PRATO_CARD('0200','0000000001','31/10/2005','020103493','P','020104010','P');
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'TROCA_PRATO_CARD' AND
	        TYPE = 'P' 		    AND
	        U.UID = O.UID               AND
	        U.NAME = USER)
DROP PROCEDURE TROCA_PRATO_CARD;
GO

CREATE PROCEDURE TROCA_PRATO_CARD
   @P_LISTAFILI    VARCHAR(10),
   @P_LISTASERV    VARCHAR(10),
   @P_DTINICIAL    DATETIME,
   @P_DTFINAL      DATETIME,
   @P_CDPRATORIG   VARCHAR(10),
   @P_CDFAPRATORIG VARCHAR(4),
   @P_CDPRATDEST   VARCHAR(10),
   @P_CDFAPRATDEST VARCHAR(4),
   @P_MODOPROC     VARCHAR(1),
   @P_CDNVPRODUTO  VARCHAR(1),
   @P_CDOPERADOR   VARCHAR(12),
   @P_NRLOGINTCARD VARCHAR(10) OUTPUT
AS
   DECLARE @V_IDUTRPADCA   VARCHAR(1);
   DECLARE @V_TIPORECE     VARCHAR(1);
   DECLARE @V_IDCARDIAUTIL VARCHAR(1);
   DECLARE @V_TIPOCARDAPIO VARCHAR(1);
   DECLARE @V_NRLOGINTCARD VARCHAR(20);
   DECLARE @V_CDCONTADOR   VARCHAR(20);
   DECLARE @V_IDCARDDESCENTR VARCHAR(1);
   DECLARE @C_CDFILIAL     VARCHAR(4);
   DECLARE @C_CDSERVFILI   VARCHAR(5);
   DECLARE @C_NRCARDAPIO   VARCHAR(10);
   DECLARE @C_DTCARDAPIO   DATETIME;
   DECLARE @C_IDCARDIAESPE VARCHAR(1);
   DECLARE @C_QTCOMESTICAR DOUBLE PRECISION;
   DECLARE @V_DTMESCARD    DATETIME;
   DECLARE @C_IDPRATOESPE  VARCHAR(1);
   DECLARE @C_NRSEQPRATCAR VARCHAR(1);
   DECLARE @C_CDPRATOMAT   VARCHAR(10);
   DECLARE @C_CDFILAUXPRATMAT VARCHAR(4)  
   DECLARE @C_CDPRATO         VARCHAR(10);
   DECLARE @C_CDFILAUXPRAT    VARCHAR(4);
   DECLARE @V_DIAUTIL      INT;

   DECLARE @V_QTDIABLOQCAR DOUBLE PRECISION;

   DECLARE @V_DTPROC       DATETIME;
   DECLARE @V_DTUTIL       DATETIME;

   DECLARE @V_CONTINUE       INT;
   DECLARE @V_DTLIBECARDMATR DATETIME;
   DECLARE @V_DTAPROCARDFILI DATETIME;
   DECLARE @V_DTAPROCARDMATR DATETIME;
   DECLARE @V_DTLIMAPROVFILI DATETIME;
   DECLARE @V_PRODINATIVO    VARCHAR(1);
   DECLARE @V_EXISTE_PRATO   VARCHAR(1);
   DECLARE @V_OPERDOGRUPO    VARCHAR(12);
   DECLARE @V_IDLIBMATRIZ    VARCHAR(1);
   DECLARE @V_CDPRATOMAT     VARCHAR(10);
   DECLARE @V_CDFILAUXPRATMAT VARCHAR(4);   
   DECLARE @V_IDPRATOESPE     VARCHAR(1);
   DECLARE @V_IDCARDIAESPE    VARCHAR(1);
   DECLARE @V_IDMANCORCARDALT VARCHAR(1);

   /*cursor de receita serv*/
   DECLARE @C_CDARVPROD    VARCHAR(20);
   DECLARE @C_IDPRODATIVPR VARCHAR(1);
   DECLARE @C_IDPRODATIV   VARCHAR(1);

BEGIN
   /* Verifica parametro Utiliza Receita Padrao no cardapio */
   SELECT @V_IDUTRPADCA   = ISNULL(IDUTRPADCA, 'N'),
          @V_QTDIABLOQCAR = ISNULL(QTDIABLOQCAR, 0),
          @V_TIPOCARDAPIO = ISNULL(IDUTCARDPADR, 'N'),
          @V_IDMANCORCARDALT = IDMANCORCARDALT
   FROM PARAMGERAL
   WHERE CDPARGERAL = '0001';

   SET @V_NRLOGINTCARD = NULL;
   SET @V_CONTINUE     = 0;
   SET @V_PRODINATIVO  = '0';

   /* Corre os cardapios selecionados */
   DECLARE C_CARDAPIOS CURSOR FOR

      SELECT C.CDFILIAL, C.CDSERVFILI, ISNULL(S.IDCARDDESCENTR, 'N') AS IDCARDDESCENTR, C.DTCARDAPIO,
             C.NRCARDAPIO, ISNULL(C.IDCARDIAESPE, 'N') AS IDCARDIAESPE, ISNULL(C.QTCOMESTICAR, 0) QTCOMESTICAR,
             C.DTMESCARD
      FROM   CARDADIA C LEFT JOIN CARDAMES CM
                                   ON (C.CDFILIAL   = CM.CDFILIAL  ) AND
                                      (C.CDSERVFILI = CM.CDSERVFILI) AND
                                      (C.DTMESCARD  = CM.DTMESCARDAPIO ),   
             LISTA LF, SERVICO S, (SELECT SUBSTRING(CDLISTA, 1, 4) AS  CDFILIAL, 
                                          SUBSTRING(CDLISTA, 5, 5) AS CDSERVIFILI 
                                    FROM        LISTA
                                   WHERE NRLISTA = @P_LISTASERV)LS
      WHERE  LF.NRLISTA   = @P_LISTAFILI   AND
             C.CDFILIAL   = LF.CDLISTA     AND
             C.CDSERVFILI = LS.CDSERVIFILI AND
             C.DTCARDAPIO BETWEEN @P_DTINICIAL AND @P_DTFINAL AND
             C.CDFILIAL   = S.CDFILIAL     AND
             C.CDSERVFILI = S.CDSERVFILI
      ORDER BY C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO

   OPEN C_CARDAPIOS;
   FETCH NEXT FROM C_CARDAPIOS INTO @C_CDFILIAL, @C_CDSERVFILI, @V_IDCARDDESCENTR, @C_DTCARDAPIO,
                                    @C_NRCARDAPIO, @C_IDCARDIAESPE, @C_QTCOMESTICAR, @V_DTMESCARD;

   WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_TIPOCARDAPIO = 'D') AND (@V_IDCARDDESCENTR = 'S') AND (@P_MODOPROC = 'F') BEGIN
            /*Verifica se o servio j est LIBERADO pela matriz, APROVADO pela filial,
              APROVADO pela matriz ou se a data de LIMITE de aprovao pela filial expirou*/
            SET @V_CONTINUE = 0;  /*Recebe false para limpar o valor quando for exportar para 2 meses*/
            SELECT @V_DTLIBECARDMATR = CTRL.DTLIBECARDMATR,
                   @V_DTAPROCARDFILI = CTRL.DTAPROCARDFILI,
                   @V_DTAPROCARDMATR = CTRL.DTAPROCARDMATR,
                   @V_DTLIMAPROVFILI = CALE.DTLIMAPROVFILI + ISNULL(QTDIAPRORAPROV , 0)
            FROM   CTRLAPROVCARD CTRL, CALENCARD CALE
            WHERE  CTRL.CDFILIAL       = @C_CDFILIAL   AND
                   CTRL.CDSERVFILI     = @C_CDSERVFILI AND
                   CTRL.DTMESCARDAPROV = @V_DTMESCARD  AND
                   CTRL.CDFILIAL       = CALE.CDFILIAL AND
                   CTRL.DTMESCARDAPROV = CALE.DTMESCALENCARD;
         
            /*Cardpio NO liberado pela MATRIZ*/
            IF @V_DTLIBECARDMATR IS NULL BEGIN
               SET @V_CONTINUE = 1;
            END;
            /*Cardpio J aprovado pela FILIAL*/
            IF NOT @V_DTAPROCARDFILI IS NULL BEGIN
               SET @V_CONTINUE = 1;
            END;
            /*Cardpio J aprovado pela MATRIZ*/
            IF NOT @V_DTAPROCARDMATR IS NULL BEGIN
               SET @V_CONTINUE = 1;
            END;
            /*Data limite de aprovao pela FILIAL expirada*/
            IF CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) >
               CONVERT(DATETIME, CONVERT(VARCHAR, @V_DTLIMAPROVFILI, 103)) BEGIN
               SET @V_CONTINUE = 1;
            END;
         END ELSE BEGIN
            SET @V_CONTINUE = 0;
         END;
         
         IF @V_CONTINUE = 0 BEGIN
            SELECT @V_DTPROC = MAX(CASE PG.IDUTILDTPROC
                                      WHEN 'S' THEN PF.DTPROCESSA
                                      ELSE CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103))
                                   END)
            FROM   PARAMFILIAL PF, PARAMGERAL PG
            WHERE  PF.CDFILIAL = @C_CDFILIAL AND
                   PG.CDPARGERAL = '0001';

            IF (@V_DTPROC IS NULL) BEGIN
               SET @V_DTPROC = CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103));
            END;

            IF (@C_DTCARDAPIO >= (@V_DTPROC + @V_QTDIABLOQCAR)) BEGIN
               SELECT @V_IDCARDIAUTIL = MAX(ISNULL(IDCARDIAUTIL, 'N'))
               FROM   PARAMPLANEJA
               WHERE  CDFILIAL = @C_CDFILIAL;

               SET @V_DIAUTIL = 1;
               IF (@V_IDCARDIAUTIL = 'S') BEGIN
                  SELECT @V_DTUTIL = MAX(DTFERIFILI)
                  FROM   FERIFILI
                  WHERE  CDFILIAL   = @C_CDFILIAL AND
                         DTFERIFILI = @C_DTCARDAPIO;

                  IF (@V_DTUTIL IS NOT NULL) BEGIN
                     SET @V_DIAUTIL = 0;
                  END;
               END;

               IF (@V_DIAUTIL = 1) BEGIN
                  IF (@C_QTCOMESTICAR = 0) BEGIN
                  /* 1- Comensais do dia zerados */
                     IF @V_NRLOGINTCARD IS NULL BEGIN
                        SET @V_CDCONTADOR = 'LOGINTCARD' + @C_CDFILIAL;
                        EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRLOGINTCARD OUTPUT, @P_QTDE = 1;
                        SET @V_NRLOGINTCARD = SUBSTRING(@V_NRLOGINTCARD,11,10);
                     END;
                     EXEC GRAVA_LOGINTCARD @V_NRLOGINTCARD, @C_CDFILIAL, @C_CDFILIAL, @C_CDSERVFILI, @C_DTCARDAPIO, ' ', ' ', ' ', '1';
                  END
                  ELSE BEGIN

                  /* Verificar a receita utilizada pelo prato destino */
                     SET @V_TIPORECE = 'N';
                     SELECT @V_TIPORECE = ISNULL(MAX(TIPO),'N')
                     FROM  (SELECT 'S' AS TIPO
                            FROM   RECESERV
                            WHERE  (CDFILIAL     = @C_CDFILIAL)   AND
                                   (CDSERVFILI   = @C_CDSERVFILI) AND
                                   (CDPRATO      = @P_CDPRATDEST)    AND
                                   (CDFILAUXPRAT = @P_CDFAPRATDEST)
                            UNION ALL
                            SELECT 'F' AS TIPO
                            FROM   RECEFILI F
                            WHERE  (CDFILIAL     = @C_CDFILIAL)   AND
                                   (CDPRATO      = @P_CDPRATDEST)    AND
                                   (CDFILAUXPRAT = @P_CDFAPRATDEST) AND
                                   NOT EXISTS (SELECT CDPRATO
                                               FROM   RECESERV
                                               WHERE  (CDFILIAL     = @C_CDFILIAL)   AND
                                                      (CDSERVFILI   = @C_CDSERVFILI) AND
                                                      (CDPRATO      = @P_CDPRATDEST) AND
                                                      (CDFILAUXPRAT = @P_CDFAPRATDEST))
                            UNION ALL
                            SELECT 'P' AS TIPO
                            FROM   RECEPADR P
                            WHERE  (CDPRATO      = @P_CDPRATDEST)    AND
                                   (CDFILAUXPRAT = @P_CDFAPRATDEST) AND
                                   NOT EXISTS (SELECT CDPRATO
                                               FROM   RECEFILI
                                               WHERE  (CDFILIAL     = @C_CDFILIAL)   AND
                                                      (CDPRATO      = @P_CDPRATDEST) AND
                                                      (CDFILAUXPRAT = @P_CDFAPRATDEST)) AND
                                   NOT EXISTS (SELECT CDPRATO
                                               FROM   RECESERV
                                               WHERE  (CDFILIAL     = @C_CDFILIAL)   AND
                                                      (CDSERVFILI   = @C_CDSERVFILI) AND
                                                      (CDPRATO      = @P_CDPRATDEST)    AND
                                                      (CDFILAUXPRAT = @P_CDFAPRATDEST))) A;

                     IF (@V_TIPORECE = 'N') BEGIN
                     /* 2- Prato sem receita */
                        IF @V_NRLOGINTCARD IS NULL BEGIN
                           SET @V_CDCONTADOR = 'LOGINTCARD' + @C_CDFILIAL;
                           EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRLOGINTCARD OUTPUT, @P_QTDE = 1;
                           SET @V_NRLOGINTCARD = SUBSTRING(@V_NRLOGINTCARD,11,10);
                        END;
                        EXEC GRAVA_LOGINTCARD @V_NRLOGINTCARD, @C_CDFILIAL, @C_CDFILIAL, @C_CDSERVFILI, @C_DTCARDAPIO, ' ', ' ', ' ', '2';

                     END
                     ELSE BEGIN
                        /*VERIFICAR SE EXISTE O PRATO NO CARDAPIO DESTINO*/
                          SELECT @V_EXISTE_PRATO = EXISTE
                          FROM ( SELECT 'S' EXISTE
                                 FROM COMPCARD
                                 WHERE  CDFILIAL     = @C_CDFILIAL AND
                                        NRCARDAPIO   = @C_NRCARDAPIO AND
                                        CDPRATO      = @P_CDPRATORIG AND
                                        CDFILAUXPRAT = @P_CDFAPRATORIG)A
                          GROUP BY EXISTE;

                        SET @V_PRODINATIVO = '0';
                        IF (@V_EXISTE_PRATO ='S') BEGIN /*SE EXISTIR O PRATO NO CARDAPIO DESTINO*/
                           IF (@V_TIPORECE = 'S') BEGIN  /*RECEITA POR SERVIO COM PRODUTO INATIVO geovane*/
                               DECLARE C_RECESERV CURSOR FOR
                                   SELECT  P.CDARVPROD, P.IDPRODATIVPR, ISNULL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                   FROM   RECESERV RS,
                                          PRODUTO P LEFT JOIN PRODFILI PF
                                               ON (P.CDPRODUTO = PF.CDPRODUTO) AND
                                                  (@C_CDFILIAL = PF.CDFILIAL)
                                   WHERE  P.CDNVPRODUTO   = @P_CDNVPRODUTO  AND
                                          RS.CDFILIAL     = @C_CDFILIAL     AND
                                          RS.CDSERVFILI   = @C_CDSERVFILI   AND
                                          RS.CDPRATO      = @P_CDPRATDEST   AND
                                          RS.CDFILAUXPRAT = @P_CDFAPRATDEST AND
                                          P.CDPRODUTO     = RS.CDPRODUTO
                              OPEN C_RECESERV;
                              FETCH NEXT FROM C_RECESERV INTO @C_CDARVPROD,
                                                              @C_IDPRODATIVPR, @C_IDPRODATIV;
                              WHILE (@@FETCH_STATUS = 0) BEGIN
                                IF (@C_IDPRODATIV = 'I') OR (@C_IDPRODATIVPR = 'N') BEGIN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                   IF @V_NRLOGINTCARD IS NULL BEGIN
                                      SET @V_CDCONTADOR = 'LOGINTCARD' + @C_CDFILIAL;
                                      EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRLOGINTCARD OUTPUT, @P_QTDE = 1;
                                      SET @V_NRLOGINTCARD = SUBSTRING(@V_NRLOGINTCARD,11,10);
                                   END;
                                   SET @V_PRODINATIVO = '1';
                                   /*GRAVA_LOGINTCARD(V_NRLOGINTCARD, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDSERVFILI, C_CARDAPIOS.DTCARDAPIO, C_RECESERV.CDARVPROD, ' ', P_CDFAPRATDEST,  '0');*//*CONFERIR*/
                                   EXEC GRAVA_LOGINTCARD @V_NRLOGINTCARD, @C_CDFILIAL, @C_CDFILIAL, @C_CDSERVFILI, @C_DTCARDAPIO, @C_CDARVPROD, ' ', @P_CDFAPRATDEST, '0';/*DECLARAR CURSOR RECESERV*/
                                END;
                                FETCH NEXT FROM C_RECESERV INTO @C_CDARVPROD,
                                                                @C_IDPRODATIVPR, @C_IDPRODATIV;
                              END;
                              CLOSE C_RECESERV;
                              DEALLOCATE C_RECESERV;
                           END
                           ELSE BEGIN
                             IF (@V_TIPORECE = 'F') BEGIN  /*RECEITA LOCAL COM PRODUTO INATIVO geovane*/
                                
                                DECLARE C_RECEFILI CURSOR FOR
                                     SELECT P.CDARVPROD, P.IDPRODATIVPR, ISNULL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                     FROM   RECEFILI RF,
                                            PRODUTO P LEFT JOIN PRODFILI PF
                                                 ON (P.CDPRODUTO = PF.CDPRODUTO) AND
                                                    (@C_CDFILIAL = PF.CDFILIAL)
                                     WHERE  P.CDNVPRODUTO   = @P_CDNVPRODUTO  AND
                                            RF.CDFILIAL     = @C_CDFILIAL     AND
                                            RF.CDPRATO      = @P_CDPRATDEST   AND
                                            RF.CDFILAUXPRAT = @P_CDFAPRATDEST AND
                                            P.CDPRODUTO     = RF.CDPRODUTO
                                OPEN C_RECEFILI;
                                FETCH NEXT FROM C_RECEFILI INTO @C_CDARVPROD,
                                                                @C_IDPRODATIVPR, @C_IDPRODATIV;
                                WHILE (@@FETCH_STATUS = 0) BEGIN
                                  IF (@C_IDPRODATIV = 'I') OR (@C_IDPRODATIVPR = 'N') BEGIN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                     IF @V_NRLOGINTCARD IS NULL BEGIN
                                        SET @V_CDCONTADOR = 'LOGINTCARD' + @C_CDFILIAL;
                                        EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRLOGINTCARD OUTPUT, @P_QTDE = 1;
                                        SET @V_NRLOGINTCARD = SUBSTRING(@V_NRLOGINTCARD,11,10);
                                     END;
                                     SET @V_PRODINATIVO = '1';
                                     EXEC GRAVA_LOGINTCARD @V_NRLOGINTCARD, @C_CDFILIAL, @C_CDFILIAL, @C_CDSERVFILI, @C_DTCARDAPIO, @C_CDARVPROD, ' ', @P_CDFAPRATDEST, '0';
                                  END;
                                  FETCH NEXT FROM C_RECEFILI INTO @C_CDARVPROD,
                                                                  @C_IDPRODATIVPR, @C_IDPRODATIV;
                                END;
                                CLOSE C_RECEFILI;
                                DEALLOCATE C_RECEFILI;
                             END
                             ELSE BEGIN
                               IF (@V_TIPORECE ='P') BEGIN   /*RECEITA PADRO COM PRODUTO INATIVO*/
                                     DECLARE C_RECEPADR CURSOR FOR
                                          SELECT P.CDARVPROD, P.IDPRODATIVPR, ISNULL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                          FROM  RECEPADR RP,
                                                PRODUTO P LEFT JOIN PRODFILI PF
                                                      ON (P.CDPRODUTO = PF.CDPRODUTO) AND
                                                         (@C_CDFILIAL = PF.CDFILIAL)
                                          WHERE  P.CDNVPRODUTO        = @P_CDNVPRODUTO   AND
                                                 RP.CDPRATO           = @P_CDPRATDEST    AND
                                                 RP.CDFILAUXPRAT      = @P_CDFAPRATDEST  AND
                                                 RP.CDPRODUTO         = P.CDPRODUTO
                                     OPEN C_RECEPADR;
                                     FETCH NEXT FROM C_RECEPADR INTO @C_CDARVPROD,
                                                                     @C_IDPRODATIVPR, @C_IDPRODATIV;
                                     WHILE (@@FETCH_STATUS = 0) BEGIN
                                       IF (@C_IDPRODATIV = 'I') OR (@C_IDPRODATIVPR = 'N') BEGIN /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                          IF @V_NRLOGINTCARD IS NULL BEGIN
                                             SET @V_CDCONTADOR = 'LOGINTCARD' + @C_CDFILIAL;
                                             EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRLOGINTCARD OUTPUT, @P_QTDE = 1;
                                             SET @V_NRLOGINTCARD = SUBSTRING(@V_NRLOGINTCARD,11,10);
                                          END;
                                          SET @V_PRODINATIVO = '1';
                                          EXEC GRAVA_LOGINTCARD @V_NRLOGINTCARD, @C_CDFILIAL, @C_CDFILIAL, @C_CDSERVFILI, @C_DTCARDAPIO, @C_CDARVPROD, ' ', @P_CDFAPRATDEST, '0';
                                       END;
                                       FETCH NEXT FROM C_RECEPADR INTO @C_CDARVPROD,
                                                                       @C_IDPRODATIVPR, @C_IDPRODATIV;
                                     END ;
                                     CLOSE C_RECEPADR;
                                     DEALLOCATE C_RECEPADR;
                               END; /*RECEITA PADRO COM PRODUTO INATIVO*/
                             END;  /*RECEITA LOCAL COM PRODUTO INATIVO geovane*/
                           END; /*RECEITA POR SERVIO COM PRODUTO INATIVO geovane*/
                        END;/*SE EXISTIR O PRATO NO CARDAPIO DESTINO*/


                        IF (@V_TIPORECE = 'P' AND @V_IDUTRPADCA = 'N') BEGIN
                        /* 3- Prato sem receita revisada */
                           IF @V_NRLOGINTCARD IS NULL BEGIN
                              SET @V_CDCONTADOR = 'LOGINTCARD' + @C_CDFILIAL;
                              EXEC NOVO_CODIGO @V_CDCONTADOR, @P_SEQUENCIAL = @V_NRLOGINTCARD OUTPUT, @P_QTDE = 1;
                              SET @V_NRLOGINTCARD = SUBSTRING(@V_NRLOGINTCARD,11,10);
                           END;
                           EXEC GRAVA_LOGINTCARD @V_NRLOGINTCARD, @C_CDFILIAL, @C_CDFILIAL, @C_CDSERVFILI, @C_DTCARDAPIO, @P_CDPRATDEST, ' ', @P_CDFAPRATDEST, '3';

                        END
                        ELSE BEGIN
                           IF (@V_PRODINATIVO = '0') BEGIN /*PRODUTO INATIVO NO PRATO*/
                                /* OK - Substitui prato */
                               /*Cardpio LIVRE*/
                              IF (@V_TIPOCARDAPIO = 'N') BEGIN
                                  UPDATE COMPCARD
                                  SET    CDPRATO      = @P_CDPRATDEST,
                                         CDFILAUXPRAT = @P_CDFAPRATDEST
                                  WHERE  CDFILIAL     = @C_CDFILIAL AND
                                         NRCARDAPIO   = @C_NRCARDAPIO AND
                                         CDPRATO      = @P_CDPRATORIG AND
                                         CDFILAUXPRAT = @P_CDFAPRATORIG;
                               END;
                               /*Cardpio PADRONIZADO*/
                               IF (@V_TIPOCARDAPIO = 'S') BEGIN
                                  SELECT
                                     @V_OPERDOGRUPO = MAX(OP.CDOPERADOR)
                                  FROM
                                     AUTGRUPOP AP,
                                     OPERGRUPOP OP
                                  WHERE
                                     (AP.IDAUTGRUPOP = 'LRCD')        AND
                                     (AP.CDGRUPOPER  = OP.CDGRUPOPER) AND
                                     (OP.CDOPERADOR  = @P_CDOPERADOR);
                                  /*Operador pertence ao grupo com permisso para revisar cardpio*/
                                  IF (@V_OPERDOGRUPO IS NULL) BEGIN
                                     UPDATE COMPCARD
                                     SET    CDPRATO      = @P_CDPRATDEST,
                                            CDFILAUXPRAT = @P_CDFAPRATDEST,
                                            IDPRATOESPE  = 'S'
                                     WHERE  CDFILIAL     = @C_CDFILIAL AND
                                            NRCARDAPIO   = @C_NRCARDAPIO AND
                                            CDPRATO      = @P_CDPRATORIG AND
                                            CDFILAUXPRAT = @P_CDFAPRATORIG;

                                     IF @C_IDCARDIAESPE = 'N' BEGIN
                                        UPDATE CARDADIA
                                        SET    IDCARDIAESPE = 'S'
                                        WHERE  CDFILIAL   = @C_CDFILIAL AND
                                               NRCARDAPIO = @C_NRCARDAPIO;
                                     END;
                                  END ELSE BEGIN
                                     UPDATE COMPCARD
                                     SET    CDPRATO      = @P_CDPRATDEST,
                                            CDFILAUXPRAT = @P_CDFAPRATDEST,
                                            IDPRATOESPE  = 'R'
                                     WHERE  CDFILIAL     = @C_CDFILIAL AND
                                            NRCARDAPIO   = @C_NRCARDAPIO AND
                                            CDPRATO      = @P_CDPRATORIG AND
                                            CDFILAUXPRAT = @P_CDFAPRATORIG;

                                            
                                    /* IF @C_IDCARDIAESPE = 'N' BEGIN
                                        UPDATE CARDADIA
                                        SET    IDCARDIAESPE = 'R'
                                        WHERE  CDFILIAL   = @C_CDFILIAL AND
                                               NRCARDAPIO = @C_NRCARDAPIO;
                                     END; */


                                  END; /*Operador pertence ao grupo com permisso para revisar cardpio*/
                               END; /*Cardpio PADRONIZADO*/

                               IF (@V_TIPOCARDAPIO = 'D') BEGIN /*Cardpio DESCENTRALIZADO*/
                                  DECLARE C_PRATOS CURSOR FOR
                                     SELECT IDPRATOESPE, NRSEQPRATCAR, CDPRATOMAT, CDFILAUXPRATMAT, CDPRATO, CDFILAUXPRAT
                                     FROM   COMPCARD
                                     WHERE  CDFILIAL     = @C_CDFILIAL   AND
                                            NRCARDAPIO   = @C_NRCARDAPIO AND
                                            CDPRATO      = @P_CDPRATORIG AND
                                            CDFILAUXPRAT = @P_CDFAPRATORIG
                                  OPEN C_PRATOS;
                                  FETCH NEXT FROM C_PRATOS INTO @C_IDPRATOESPE, @C_NRSEQPRATCAR, @C_CDPRATOMAT, 
                                                                @C_CDFILAUXPRATMAT, @C_CDPRATO, @C_CDFILAUXPRAT;
                                  WHILE (@@FETCH_STATUS = 0) BEGIN
                                     IF @P_MODOPROC = 'M' BEGIN
                                        SELECT @V_IDLIBMATRIZ = 'S'
                                          FROM CTRLAPROVCARD
                                         WHERE CDFILIAL = @C_CDFILIAL
                                           AND CDSERVFILI = @C_CDSERVFILI
                                           AND DTMESCARDAPROV = @V_DTMESCARD
                                           AND DTLIBECARDMATR IS NOT NULL;
                                        IF (@V_IDLIBMATRIZ = 'S') BEGIN
                                           IF ((@C_CDPRATOMAT = @P_CDPRATDEST) AND
                                               (@C_CDFILAUXPRATMAT = @P_CDFAPRATDEST)) BEGIN
                                              IF @V_IDMANCORCARDALT = 'S' BEGIN
                                                 SET @V_IDPRATOESPE = 'R';
                                                 SET @V_IDCARDIAESPE = 'S';                                                   
                                                 SET @V_CDPRATOMAT = @C_CDPRATOMAT;
                                                 SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRATMAT;
                                              END ELSE BEGIN
                                                 SET @V_IDPRATOESPE = 'N';
                                                 SET @V_IDCARDIAESPE = 'N';                                                
                                                 SET @V_CDPRATOMAT = NULL;
                                                 SET @V_CDFILAUXPRATMAT = NULL;
                                              END;
                                           END ELSE BEGIN
                                              IF (@C_CDPRATOMAT IS NULL) AND 
                                                 (@C_CDFILAUXPRATMAT IS NULL) BEGIN
                                                 IF @C_IDPRATOESPE = 'N' BEGIN
                                                    SET @V_IDPRATOESPE = 'R';
                                                    SET @V_IDCARDIAESPE = 'S';
                                                    SET @V_CDPRATOMAT = @C_CDPRATO;
                                                    SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRAT;
                                                 END ELSE BEGIN
                                                    SET @V_IDPRATOESPE = 'R';
                                                    SET @V_IDCARDIAESPE = 'S';
                                                    SET @V_CDPRATOMAT = @C_CDPRATOMAT;
                                                    SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRATMAT;
                                                 END;   
                                              END ELSE BEGIN
                                                 SET @V_IDPRATOESPE = 'R';
                                                 SET @V_IDCARDIAESPE = 'S';
                                                 SET @V_CDPRATOMAT = @C_CDPRATOMAT;
                                                 SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRATMAT;
                                              END;
                                           END; 
                                        END ELSE BEGIN
                                           SET @V_IDPRATOESPE = 'N';
                                           SET @V_IDCARDIAESPE = 'N';
                                           SET @V_CDPRATOMAT = NULL;
                                           SET @V_CDFILAUXPRATMAT = NULL;
                                        END;
                                     END ELSE BEGIN   
                                        IF (@C_CDPRATOMAT = @P_CDPRATDEST) AND 
                                           (@C_CDFILAUXPRATMAT = @P_CDFAPRATDEST) BEGIN
                                           /*SE O PRATO INSERIDO FOR IGUAL AO LIBERADO PELA MATRIZ VERIFICA O PARAMETRO(SOLI.77247)*/
                                           IF @V_IDMANCORCARDALT = 'S' BEGIN
                                              SET @V_IDPRATOESPE = 'S';
                                              SET @V_IDCARDIAESPE = 'S'
                                              SET @V_CDPRATOMAT = @C_CDPRATOMAT;
                                              SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRATMAT;
                                           END ELSE BEGIN
                                              SET @V_IDPRATOESPE = 'N';
                                              SET @V_IDCARDIAESPE = 'N';
                                              SET @V_CDPRATOMAT = NULL;
                                              SET @V_CDFILAUXPRATMAT = NULL;
                                           END;   
                                        END ELSE BEGIN
                                           IF (@C_CDPRATOMAT IS NULL) AND 
                                              (@C_CDFILAUXPRATMAT IS NULL) BEGIN
                                              IF @C_IDPRATOESPE = 'N' BEGIN
                                                 SET @V_IDPRATOESPE = 'S';
                                                 SET @V_IDCARDIAESPE = 'S';
                                                 SET @V_CDPRATOMAT = @C_CDPRATO;
                                                 SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRAT;
                                              END ELSE BEGIN
                                                 SET @V_IDPRATOESPE = 'S';
                                                 SET @V_IDCARDIAESPE = 'S';
                                                 SET @V_CDPRATOMAT = @C_CDPRATOMAT;
                                                 SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRATMAT;
                                              END;   
                                           END ELSE BEGIN   
                                              SET @V_IDPRATOESPE = 'S';
                                              SET @V_IDCARDIAESPE = 'S';
                                              SET @V_CDPRATOMAT = @C_CDPRATOMAT;
                                              SET @V_CDFILAUXPRATMAT = @C_CDFILAUXPRATMAT;
                                           END;
                                        END; 
                                     END; 
                                     IF @P_MODOPROC = 'F' BEGIN
                                        IF (@C_CDPRATOMAT IS NULL) AND 
                                           (@C_CDFILAUXPRATMAT IS NULL) BEGIN
                                           /*UTILIZA DOIS UPDATE PARA NO ENTRAR NA CONDIO DA TRIGGER 
                                            'GERA_HISTORICO_CARD' DA TABELA COMPCARD*/
                                           UPDATE COMPCARD                                                
                                              SET CDPRATO      = @P_CDPRATDEST,
                                                  CDFILAUXPRAT = @P_CDFAPRATDEST,
                                                  IDPRATOESPE  = NULL,
                                                  CDPRATOMAT   = @V_CDPRATOMAT,
                                                  CDFILAUXPRATMAT = @V_CDFILAUXPRATMAT
                                            WHERE CDFILIAL     = @C_CDFILIAL
                                              AND NRCARDAPIO   = @C_NRCARDAPIO
                                              AND CDPRATO      = @P_CDPRATORIG
                                              AND CDFILAUXPRAT = @P_CDFAPRATORIG
                                              AND NRSEQPRATCAR = @C_NRSEQPRATCAR;

                                           UPDATE COMPCARD                                                
                                              SET IDPRATOESPE  = @V_IDPRATOESPE
                                            WHERE CDFILIAL     = @C_CDFILIAL
                                              AND NRCARDAPIO   = @C_NRCARDAPIO
                                              AND CDPRATO      = @P_CDPRATDEST
                                              AND CDFILAUXPRAT = @P_CDFAPRATDEST
                                              AND NRSEQPRATCAR = @C_NRSEQPRATCAR;
                                        END ELSE BEGIN
                                           UPDATE COMPCARD                                                
                                              SET CDPRATO      = @P_CDPRATDEST,
                                                  CDFILAUXPRAT = @P_CDFAPRATDEST,
                                                  IDPRATOESPE  = @V_IDPRATOESPE,
                                                  CDPRATOMAT   = @V_CDPRATOMAT,
                                                  CDFILAUXPRATMAT = @V_CDFILAUXPRATMAT
                                            WHERE CDFILIAL     = @C_CDFILIAL
                                              AND NRCARDAPIO   = @C_NRCARDAPIO
                                              AND CDPRATO      = @P_CDPRATORIG
                                              AND CDFILAUXPRAT = @P_CDFAPRATORIG
                                              AND NRSEQPRATCAR = @C_NRSEQPRATCAR;
                                        END;
                                     END ELSE BEGIN
                                        UPDATE COMPCARD                                                
                                           SET CDPRATO      = @P_CDPRATDEST,
                                               CDFILAUXPRAT = @P_CDFAPRATDEST,
                                               IDPRATOESPE  = @V_IDPRATOESPE,
                                               CDPRATOMAT   = @V_CDPRATOMAT,
                                               CDFILAUXPRATMAT = @V_CDFILAUXPRATMAT
                                         WHERE CDFILIAL     = @C_CDFILIAL
                                           AND NRCARDAPIO   = @C_NRCARDAPIO
                                           AND CDPRATO      = @P_CDPRATORIG
                                           AND CDFILAUXPRAT = @P_CDFAPRATORIG
                                           AND NRSEQPRATCAR = @C_NRSEQPRATCAR;
                                     END;   

                                     UPDATE CARDADIA
                                        SET IDCARDIAESPE = @V_IDCARDIAESPE
                                      WHERE CDFILIAL   = @C_CDFILIAL 
                                        AND NRCARDAPIO = @C_NRCARDAPIO;                                                                                          
                                     FETCH NEXT FROM C_PRATOS INTO @C_IDPRATOESPE, @C_NRSEQPRATCAR, @C_CDPRATOMAT, 
                                                                   @C_CDFILAUXPRATMAT, @C_CDPRATO, @C_CDFILAUXPRAT;
                                  END; 
                                  CLOSE C_PRATOS;
                                  DEALLOCATE C_PRATOS;
                               END;
                           END;/*PRODUTO INATIVO NO PRATO*/
                        END; /* 3- Prato sem receita revisada */


                     END;/* 2- Prato sem receita */
                  END;
               END;
            END;
         
      END;
      FETCH NEXT FROM C_CARDAPIOS INTO @C_CDFILIAL, @C_CDSERVFILI, @V_IDCARDDESCENTR, @C_DTCARDAPIO,
                                       @C_NRCARDAPIO, @C_IDCARDIAESPE, @C_QTCOMESTICAR, @V_DTMESCARD;

   END;
   CLOSE C_CARDAPIOS;
   DEALLOCATE C_CARDAPIOS;
   SET @P_NRLOGINTCARD = ISNULL(@V_NRLOGINTCARD, '');
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'TROCA_PRATO_CARD','5.70.000';
GO

